DROP TABLE accounts;

CREATE TABLE accounts (
    account_id INT NOT NULL,
    account_username VARCHAR(50) NOT NULL UNIQUE,
    account_password VARCHAR(50) NOT NULL,
    email VARCHAR(50),
    created TIMESTAMP,
    modified TIMESTAMP
);

INSERT INTO accounts VALUES (1,'user1','password1','user1@email.com',SYSDATE,SYSDATE);

SELECT * FROM accounts;

CREATE OR REPLACE PROCEDURE 
    insert_account(uname VARCHAR, 
                   pword VARCHAR, 
                   email VARCHAR) AS
    next_id INT;
BEGIN
    SELECT MAX(account_id) + 1 INTO next_id FROM accounts;
    INSERT INTO accounts VALUES (next_id,uname,pword,email,SYSDATE,SYSDATE);
    dbms_output.put_line('new account inserted');
END;

EXECUTE insert_account('user2','password2','user2@email.com');
EXECUTE insert_account('user3','password3','user3@email.com');
SELECT * FROM accounts;

CREATE OR REPLACE PROCEDURE
    change_password(uname VARCHAR, 
                    new_pword VARCHAR) AS
    uname_count INT;
BEGIN
    SELECT COUNT(*) INTO uname_count FROM accounts WHERE account_username = uname;
    IF uname_count = 0 THEN
        dbms_output.put_line('No account found');
    ELSE
        UPDATE accounts
        SET account_password = new_pword,
            modified = SYSDATE
        WHERE account_username = uname;
        dbms_output.put_line('password for ' || uname || ' changed');
    END IF;
END;

EXECUTE change_password('user5','passssss5');
EXECUTE change_password('user2','passssss3');
SELECT * FROM accounts;