SET SERVEROUTPUT ON;

CREATE OR REPLACE PROCEDURE 
    insert_employee(eid VARCHAR,
                    fname VARCHAR, 
                    lname VARCHAR,
                    exp_y NUMBER,
                    salary NUMBER) AS
BEGIN
    INSERT INTO employees VALUES (eid,fname,lname,exp_y,salary);
    dbms_output.put_line('new employee inserted');
END;

EXECUTE insert_employee('00006','Gale','G',5,80000);
EXECUTE insert_employee('00007','Han','H',2,60000);
EXECUTE insert_employee('00008','Ian','I',3,60000);

SELECT * FROM employees;


/*insert with auto increment ID*/
DROP TABLE students;
CREATE TABLE students (
    student_id INT NOT NULL,
    first_name VARCHAR(20),
    last_name VARCHAR(20),
    CONSTRAINT student_pk PRIMARY KEY (student_id)
);

INSERT INTO students VALUES(1,'Alice','A');

CREATE OR REPLACE PROCEDURE 
    insert_student(fname VARCHAR, 
                   lname VARCHAR
                  ) AS
    current_max_id INT;
BEGIN
    /*find current max id*/
    SELECT MAX(student_id) INTO current_max_id FROM students;
    
    /*insert student*/
    INSERT INTO students VALUES (current_max_id+1,fname,lname);
    dbms_output.put_line('new student inserted');
END;

EXECUTE insert_student('Bob','B');
EXECUTE insert_student('Craig','C');

SELECT * FROM students;

/***loop examples***/
DECLARE 
    i INT; 
BEGIN i := 0; 
    LOOP   
        IF i <= 10 THEN 
            i := i + 1;     
            dbms_output.put_line(i);   
        ELSE     
            EXIT;   
        END IF; 
    END LOOP;
END;

/*for*/
DECLARE
    i INT;
BEGIN
    FOR i in 1..10 LOOP
        dbms_output.put_line(i);
    END LOOP;
END;

/*while*/
DECLARE 
    i INT; 
BEGIN i := 0; 
    WHILE i <= 10 LOOP   
        dbms_output.put_line(i);  
        i := i+1;
    END LOOP;
END;

/*continue and exit*/
DECLARE
    i INT;
BEGIN
    FOR i in 1..10 LOOP
        IF i MOD 2 = 0 THEN CONTINUE;
        END IF;
        dbms_output.put_line(i);
    END LOOP;
END;

DECLARE
    i INT;
BEGIN
    FOR i in 1..10 LOOP
        IF i = 5 THEN EXIT;
        END IF;
        dbms_output.put_line(i);
    END LOOP;
END;

