/*check dictionary*/
SELECT * FROM dictionary;

/*let's say we want to count the number of views belong to user SYS in the current container*/
/*we will need to find the correct dictionary view that contains the information*/
/*first, we find dictionary views that contain information about views*/
SELECT * FROM dictionary WHERE table_name LIKE '%view%' OR comments LIKE '%view%';

/*from the previous query, the COMMENTS column let us know*/
/*table CDB_VIEWS contains information about views in the container*/
/*further chceking shows that CDB_VIEWS contains owner information*/
/*so we can use it to count the views belong to user SYS*/
SELECT * FROM CDB_VIEWS;
SELECT COUNT(*) FROM CDB_VIEWS WHERE owner='SYS';

/*now, let's find all the privileges of user SYS*/
/*first, we find tables that contains information about user privileges*/
SELECT * FROM dictionary WHERE comments LIKE '%privilege%';

/*based on the comments, CDB_SYS_PRIVS contains information*/
/*about privileges granted to users and roles in the container*/
/*so we will use it to find privileges of user SYS*/
SELECT * FROM CDB_SYS_PRIVS WHERE grantee='SYS';



